﻿using System;

using Microsoft.SharePoint.Client;
using Microsoft.SharePoint;
using System.Collections.Generic;

namespace MWG.SharePoint2010.DocumentService
{
    public class DataGridItem
    {
        public String Title { get; set; }
        public String Url { get; set; }
        public String Icon { get; set; }
        public String ListGuid { get; set; }
        public ItemType Type { get; set; }

        public DataGridItem(List list)
        {
            Title = list.Title;
            Type = ItemType.Library;
            Icon = "images/list.png";
            ListGuid = list.Id.ToString("D");
        }

        public DataGridItem(SPList list)
        {
            Title = list.Title;
            Type = ItemType.Library;
            Icon = "images/list.png";
            ListGuid = list.ID.ToString("D");
        }
        public DataGridItem(SPListItem Item)
        {
            Icon = "../../images/ICgen.gif";            
            Title = Item.Name;
            //if (Item["DocIcon"] != null)
            //{
            //    Icon = @"../../Images/" + "IC" + Item["DocIcon"].ToString() + ".gif";
            //}
            if (Item.File == null)
            {
                Icon = "/_layouts/Images/folder.gif";
            }
            else
            {
                Icon = "/_layouts/Images/" + Item.File.IconUrl;
            }
         
        }

        public DataGridItem(Folder folder)
        {
            Title = folder.Name;
            Type = ItemType.Folder;
            Icon = "images/folder.png";
            Url = folder.ServerRelativeUrl;
        }
        public DataGridItem(SPFolder folder)
        {
            Title = folder.Name;
            Type = ItemType.Folder;
            if (folder.ParentFolder != null && folder.ParentFolder.DocumentLibrary != null)
            {
                Icon = "images/folder.png";
            }
            else
            {
                Icon = "images/list.png";
            }
            Url = folder.ServerRelativeUrl;
        }

        public DataGridItem() 
        {
            Icon = "images/folder.png";
            Type = ItemType.Folder;
        }

      
    }
    public class DataGridItemComparer : IComparer<DataGridItem>
    {
        public int Compare(DataGridItem d1, DataGridItem d2)
        {
           return d1.Title.ToLower().CompareTo(d2.Title.ToLower());
        }
    }
    public enum ItemType { Library, Folder, File }
}
