﻿using System;
using System.Collections.Generic;
using System.IO;
using Microsoft.SharePoint.Client;
using System.Configuration;
using Microsoft.SharePoint;
using System.Collections;
namespace MWG.SharePoint2010.DocumentService
{
    public class DiffSiteFileOperation
    {
        private ClientContext m_clientContext;

        private string webUrl;
        public DiffSiteFileOperation(String webAddress)
        {
            //m_clientContext = new ClientContext(webAddress);
            webUrl = webAddress;
            //m_clientContext.Credentials = new System.Net.NetworkCredential(ConfigurationManager.AppSettings["POWERUSERNAME"],
            //ConfigurationManager.AppSettings["POWERUSERPWD"], ConfigurationManager.AppSettings["POWERUSERDOMAIN"]);
        }

        public void CopyFile(ExFileInformation exFileInfo)
        {
           

                FileCreationInformation info = new FileCreationInformation();
                info.Overwrite = true;
                info.Url = exFileInfo.ServerRelativePath + "/" + exFileInfo.Name;
                info.Content = exFileInfo.Content;
               // List<Byte> byteCol = new List<byte>(524288000);
                //while (true)
                //{
                //    int i = exFileInfo.Content.ReadByte();
                //    if (i == -1) break;
                //    byteCol.Add((byte)i);
                //}
                //info.Content = byteCol.ToArray();
               // byteCol = null;
                //SPSecurity.RunWithElevatedPrivileges(delegate()
                //        {
                            using (SPSite destSite = new SPSite(webUrl))
                            {
                               
                                using (SPWeb destWeb = destSite.OpenWeb())
                                {
                                   
                                    destSite.AllowUnsafeUpdates = true;
                                    destWeb.AllowUnsafeUpdates = true;
                                    SPFolder folder = destWeb.GetFolder(exFileInfo.ServerRelativePath);
                                    //SPFile webfile = destWeb.Files.Add(folder.ServerRelativeUrl + "/" + exFileInfo.Name, info.Content, true);
                                    SPFile file = null;
                                    //if force to check out before edit the file, you have to check out file first and then copy the file
                                    var properties = new Hashtable();
                                    if (!exFileInfo.KeepDocumnetID)
                                    {
                                        SPDocumentLibrary doc = (SPDocumentLibrary)destWeb.Lists[folder.ParentListId];

                                        SPFieldCollection fields = doc.Fields;

                                        //set all lookup fileds to empty or default values 2012-05-25
                                        foreach (SPField f in fields)
                                        {
                                            if (f.ReadOnlyField == false && f.Hidden == false)
                                            {
                                                if (f.GetType().ToString() == "Microsoft.SharePoint.SPFieldLookup" || f.GetType().ToString() == "Microsoft.SharePoint.SPFieldUser" || f.GetType().ToString() == "Microsoft.SharePoint.Taxonomy.TaxonomyField")
                                                {
                                                    if (f.DefaultValue == null || f.DefaultValue == "")
                                                    {
                                                        properties[f.InternalName] = "";
                                                    }
                                                    else
                                                    {
                                                        properties[f.InternalName] = f.DefaultValue;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                   
                                    if (folder.DocumentLibrary.ForceCheckout == true)
                                    {
                                        //if file already existed
                                        file = destWeb.GetFile(exFileInfo.ServerRelativePath + "/" + exFileInfo.Name);
                                        if (file != null && file.Exists)
                                        {                                           
                                            if (file.CheckOutType != Microsoft.SharePoint.SPFile.SPCheckOutType.None)
                                            {
                                                file.UndoCheckOut();
                                               // file.CheckIn("checked in by copy and move function.", SPCheckinType.OverwriteCheckIn);
                                            }
                                            if (file.CheckOutType == Microsoft.SharePoint.SPFile.SPCheckOutType.None)
                                            {
                                                file.CheckOut();
                                            }
                                        }
                                        if (exFileInfo.KeepDocumnetID)
                                        {
                                            properties["_dlc_DocId"] = exFileInfo.MWGDocumentID;
                                            properties["_dlc_DocIdPersistId"] = "True";                                           
                                            file = folder.Files.Add(exFileInfo.ServerRelativePath + "/" + exFileInfo.Name, info.Content, properties, true);      
                                        }
                                        else
                                        {
                                            file = folder.Files.Add(exFileInfo.ServerRelativePath + "/" + exFileInfo.Name, info.Content, properties, true);
                                        }
                                    }
                                    else
                                    {
                                        if (exFileInfo.KeepDocumnetID)
                                        {                                           
                                            properties["_dlc_DocId"] = exFileInfo.MWGDocumentID;
                                            properties["_dlc_DocIdPersistId"] = "True";
                                            file = folder.Files.Add(exFileInfo.ServerRelativePath + "/" + exFileInfo.Name, info.Content, properties, true);     
                                        }
                                        else
                                        {
                                            file = folder.Files.Add(exFileInfo.ServerRelativePath + "/" + exFileInfo.Name, info.Content, properties, true);
                                        }
                                    }
                                    //if (folder.DocumentLibrary.EnableVersioning == true && exFileInfo.IsMajorVersion )
                                    //{
                                    //    file.Publish("");
                                    //}

                                    if (file.CheckOutType != Microsoft.SharePoint.SPFile.SPCheckOutType.None)
                                    {
                                        file.CheckIn("", SPCheckinType.MajorCheckIn);
                                    }
                                    destWeb.AllowUnsafeUpdates = false;

                                }
                                destSite.AllowUnsafeUpdates = false;
                            }
                       // });
                //Folder targetFolder = m_clientContext.Web.GetFolderByServerRelativeUrl(exFileInfo.ServerRelativePath);
                //Microsoft.SharePoint.Client.File file = targetFolder.Files.Add(info);
                //m_clientContext.Load(file);
                //m_clientContext.ExecuteQuery();
                //if (file.CheckOutType != CheckOutType.None)
                //{
                //    file.CheckIn("", CheckinType.MajorCheckIn);
                //    m_clientContext.ExecuteQuery();
                //}
           



        }

        public void CopyFolder(ExFileInformation exFileInfo)
        {

            try
            {
                using (SPSite destSite = new SPSite(webUrl))
                {
                    destSite.AllowUnsafeUpdates = true;
                    using (SPWeb destWeb = destSite.OpenWeb())
                    {
                        destWeb.AllowUnsafeUpdates = true;
                        SPFolder targetFolder = destWeb.GetFolder(exFileInfo.ServerRelativePath);

                        targetFolder.SubFolders.Add(exFileInfo.Name);
                        targetFolder.Update();
                        destWeb.AllowUnsafeUpdates = false;
                    }
                    destSite.AllowUnsafeUpdates = false;
                }
            }
            catch
            {
                throw new Exception("you don't have enough permission to copy folder into this library.");
            }
            
            #region client Object Model
            //Folder targetFolder = m_clientContext.Web.GetFolderByServerRelativeUrl(exFileInfo.ServerRelativePath);
            //targetFolder.Folders.Add(exFileInfo.Name);
            //try
            //{
            //    m_clientContext.ExecuteQuery();
            //}
            //catch
            //{
            //    throw new Exception("you don't have enough permission to copy folder into this library.");
            //}
            #endregion
        }
    }

    public class ExFileInformation
    {
        public String Name { get; set; }
        public String ServerRelativePath { get; set; }
        public byte[] Content { get; set; }
        public bool IsMajorVersion;
        public string MWGDocumentID { get; set; }
        public bool KeepDocumnetID { get; set; }
    }
}
