﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Client;
using System.Web;
using System.Text.RegularExpressions;

namespace MWG.SharePoint2010.DocumentService
{
    public partial class CopyAndMove : System.Web.UI.Page
    {
        #region Fields
        DataGridItem m_lastSelectedItem;
        DataGridItem m_currentItem = null;
        public String m_webUrl;
        FileOperationService m_fileOperationService;
        Guid m_srcListId;
        List<int> m_srcItemsId;
        List<DataGridItem> m_list;
        SPFolder m_currentFolder;
        bool isSuccefull = true;
        StringBuilder logs = null;
        bool hasCheckedOut = false;
        bool hasDeletePermission = true;
        #endregion

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitSrcParameters();

                txtUrl.Text = SPContext.Current.Web.Url;
                BindSelectedFiles();
                GetSiteList(txtUrl.Text.Trim());

                // if there is any checked out document, pop up warning message.
                HasCheckOutFiles(m_srcItemsId, m_srcListId);
                ViewState["HASCHECHEDOUTDOCUMENT"] = hasCheckedOut;
                ViewState["HASDELETEPERMISSION"] = hasDeletePermission;
                if (hasCheckedOut)
                {
                    //alert users
                    //Alert("One or more files has been selected that is currently checked out. The move operation cannot be performed on checked out files.", false);
                    Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId6", "alert('One or more files has been selected that is currently checked out. The move operation cannot be performed on checked out files.');", true);
                    divLogs.Visible = false;
                }
                if (!hasDeletePermission)
                {
                    //alert users
                    //Alert("One or more files has been selected that is currently checked out. The move operation cannot be performed on checked out files.", false);
                    Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId6", "alert('You don not have delete permission, so you cannot use move function.');", true);
                    divLogs.Visible = false;
                }
            }
            //show loading image
            btnCopy.Attributes.Add("onclick", "var loading=document.getElementById('divLoading');if (loading==null) { return ;}else {loading.style.display='block';}");
            btnMove.Attributes.Add("onclick", "var loading=document.getElementById('divLoading');if (loading==null) { return ;}else {loading.style.display='block';}");
        }
        protected void btnLoad_Click(object sender, EventArgs e)
        {
            GetSiteList(txtUrl.Text.Trim());
        }

        protected void btnCopy_Click(object sender, EventArgs e)
        {
            string errorMgs=string.Empty;
            btnMove.Enabled = false;
            btnCopy.Enabled = false;
            // divLoading.Visible = true;
            String[] str = Request.QueryString["ItemIDs"].Split(',');
            List<int> array = new List<int>();
            foreach (String s in str)
            {
                array.Add(int.Parse(s));
            }

            OnActionArg arg = new OnActionArg();
            arg.IDList = array;
            arg.TargetUrl = lblPath.Text.Trim();
            arg.Depth = 0;

            try
            {
                //string successfulUrl = SPContext.Current.Web.Url;
                //SPLongOperation longOperation = new SPLongOperation(this.Page);

                //longOperation.LeadingHTML = "Operation in progress";
                //longOperation.TrailingHTML = "Please wait while your request is being performed";

                //longOperation.Begin();
                OnCopyAction(arg);
                // longOperation.End(successfulUrl);
            }
            catch (Exception ex)
            {
                isSuccefull = false;
                errorMgs=ex.Message;
            }
            if (isSuccefull)
            {
                Alert("Operation successfully completed", true);
            }
            else
            {
                Alert("Operation Failed with following error message " + errorMgs, false);
            }
        }
        protected void btnMove_Click(object sender, EventArgs e)
        {
            btnMove.Enabled = false;
            btnCopy.Enabled = false;
            //divLoading.Visible = true;
            String[] str = Request.QueryString["ItemIDs"].Split(',');
            List<int> array = new List<int>();
            foreach (String s in str)
            {
                array.Add(int.Parse(s));
            }

            OnActionArg arg = new OnActionArg();
            arg.IDList = array;
            arg.TargetUrl = lblPath.Text.Trim();
            arg.Depth = 0;
            OnMoveAction(arg);
        }
        protected void btnUpFolder_Click1(object sender, ImageClickEventArgs e)
        {

            if (lblPath.Text.Trim().ToUpper() == "/SITES/" || lblPath.Text.Trim().ToUpper() == "/SITES")
            {
                //disable the copy and move button
                btnCopy.Enabled = false;
                btnMove.Enabled = false;
                return;
            }

            using (SPSite site = new SPSite(txtUrl.Text.Trim()))
            {
                using (SPWeb targetWeb = site.OpenWeb())
                {
                    if (m_currentFolder == null)
                    {

                        m_currentFolder = targetWeb.GetFolder(lblPath.Text.Trim());
                    }

                    if (m_currentFolder.ParentFolder != null)
                    {
                        if (m_currentFolder.ServerRelativeUrl != "/")
                        {
                            m_list = new List<DataGridItem>();
                            foreach (SPFolder f in m_currentFolder.ParentFolder.SubFolders)
                            {

                                if (!IsInternalLibrary(f.Name))
                                {
                                    m_list.Add(new DataGridItem(f));
                                }
                            }
                            m_list.Sort(new DataGridItemComparer());
                            gridFolder.DataSource = m_list;
                            gridFolder.DataBind();

                        }
                        else
                        {
                            btnCopy.Enabled = false;
                            btnMove.Enabled = false;
                            GetSiteList(txtUrl.Text.Trim());
                        }
                    }
                }

            }
            lblPath.Text = lblPath.Text.Trim().Substring(0, lblPath.Text.Trim().LastIndexOf("/"));

            if (lblPath.Text.Trim() == "/")
                lblPath.Text = "";

            #region old client model
            //if (lblPath.Text.Trim().ToUpper() == "/SITES")
            //{
            //    //disable the copy and move button
            //    btnCopy.Enabled = false;
            //    btnMove.Enabled = false;
            //    return;
            //}
            //if (m_clientContext == null)
            //    m_clientContext = GetCurrentContext();

            //if (m_currentFolder == null)
            //{
            //    m_currentFolder = m_clientContext.Web.GetFolderByServerRelativeUrl(lblPath.Text.Trim());

            //    m_clientContext.Load(m_currentFolder);
            //}
            //if (m_currentFolder.ParentFolder != null)
            //{
            //    m_folders = m_currentFolder.ParentFolder.Folders;
            //    m_files = m_currentFolder.ParentFolder.Files;
            //    m_currentFolder = m_currentFolder.ParentFolder;
            //    m_clientContext.Load(m_folders);
            //    m_clientContext.Load(m_files);
            //    m_clientContext.Load(m_currentFolder);

            //    try
            //    {
            //        m_clientContext.ExecuteQuery();

            //        if (m_currentFolder.ServerRelativeUrl != "/")
            //        {

            //            m_list = new List<DataGridItem>();
            //            foreach (Folder f in m_folders)
            //            {
            //                if (!IsInternalLibrary(f.Name))
            //                {
            //                    m_list.Add(new DataGridItem(f));
            //                }
            //            }
            //            gridFolder.DataSource = m_list;
            //            gridFolder.DataBind();
            //        }
            //        else
            //        {
            //            //disable the copy and move button
            //            btnCopy.Enabled = false;
            //            btnMove.Enabled = false;
            //            LoadSite(txtUrl.Text.Trim());
            //        }
            //    }
            //    catch (Exception ex)
            //    {
            //        Alert("Return parent folder failed.", false);
            //    }
            //}
            //lblPath.Text = lblPath.Text.Trim().Substring(0, lblPath.Text.Trim().LastIndexOf("/"));

            #endregion

        }
        protected void gridFolder_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                // Display the company name in italics.
                //e.Row.Cells[1].Attributes["ondblclick"]                
            }
        }
        protected void gridFolder_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            GridView o = e.CommandSource as GridView;
            //check which part of the datagrid is clicked.
            if (e.CommandName.ToUpper() == "EXPAND")
            {

                if (!(bool)ViewState["HASDELETEPERMISSION"])
                {
                    btnMove.Enabled = false;
                }
                else
                {
                    btnMove.Enabled = true;
                }

                if (!(bool)ViewState["HASCHECHEDOUTDOCUMENT"])
                {
                    btnMove.Enabled = true;
                }
                else
                {
                    btnMove.Enabled = false;
                }
                btnCopy.Enabled = true;

                DataGridItem item = new DataGridItem();
                int currentIndex = int.Parse(e.CommandArgument.ToString());
                GridViewRow currentRow = o.Rows[currentIndex];
                //item.ListGuid = currentRow.Cells[4].Text.Trim().ToUpper().Replace("&NBSP;", ""); ;
                if (o.DataKeys[currentIndex].Values["ListGuid"] != null)
                {
                    item.ListGuid = o.DataKeys[currentIndex].Values["ListGuid"].ToString().Trim().ToUpper().Replace("&NBSP;", ""); ;
                }
                item.Title = currentRow.Cells[2].Text.Trim().ToUpper().Replace("&NBSP;", "");
                //item.Url = currentRow.Cells[3].Text.Trim().ToUpper().Replace("&NBSP;", ""); 
                Label lblURL = (Label)currentRow.FindControl("lblUrl");
                if (lblURL != null)
                    item.Url = lblURL.Text.Trim().ToUpper().Replace("&NBSP;", ""); ;

                m_lastSelectedItem = item;
                OpenFolder(item);
            }
        }

        #region customized code
        private void InitSrcParameters()
        {
            m_srcListId = new Guid(Request.QueryString["ListID"]);
            String[] str = Request.QueryString["ItemIDs"].Split(',');
            m_srcItemsId = new List<int>();
            foreach (String s in str)
            {
                m_srcItemsId.Add(int.Parse(s));
            }

        }
        private void BindSelectedFiles()
        {
            List<DataGridItem> selectedFolers = new List<DataGridItem>();
            List<DataGridItem> selectedFiles = new List<DataGridItem>();
            SPWeb web = SPContext.Current.Web;

            SPList currentList = web.Lists[m_srcListId];
            #region Caml no use
            //// build query caml to get all items
            //SPQuery query = new SPQuery();
            //string queryXml = "<Where><Or>";            
            //foreach (int id in m_srcItemsId)
            //{
            //    queryXml += "<Or><Eq><FieldRef Name='ID'/>" + "<Value Type='Number'>" + id + "</Value></Eq>";
            //}
            //queryXml += "</Or></Where>";
            #endregion

            foreach (int id in m_srcItemsId)
            {
                SPListItem item = currentList.GetItemById(id);
                DataGridItem ditem = new DataGridItem(item);
                if (item.File != null)
                {
                    selectedFolers.Add(ditem);
                }
                else
                {
                    selectedFiles.Add(ditem);
                }
            }
            selectedFolers.Sort(new DataGridItemComparer());
            selectedFiles.Sort(new DataGridItemComparer());
            selectedFolers.InsertRange(0, selectedFiles);
            gvfiles.DataSource = selectedFolers;
            gvfiles.DataBind();
        }
        private void GetSiteList(string siteUrl)
        {
            m_webUrl = siteUrl;
            m_currentItem = null;
            btnMove.Enabled = false;
            btnCopy.Enabled = false;

            try
            {
                using (SPSite site = new SPSite(siteUrl))
                {
                    //check user has permission to access the site.
                    SPWeb web = site.OpenWeb();
                    if (!web.DoesUserHavePermissions(SPBasePermissions.Open))
                    {
                        Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId6", "alert('You do not have permission on this site.');", true);

                        divLogs.Visible = false;
                        return;
                    }

                    List<DataGridItem> allItems = new List<DataGridItem>();
                    SPListCollection lists = site.OpenWeb().Lists;
                    foreach (SPList list in lists)
                    {
                        if (list.BaseType == SPBaseType.DocumentLibrary && !list.Hidden && list.DoesUserHavePermissions(SPBasePermissions.AddListItems))
                        {
                            DataGridItem item = new DataGridItem(list);
                            if (!IsInternalLibrary(item.Title))
                            {
                                allItems.Add(item);
                            }
                        }
                    }


                    allItems.Sort(new DataGridItemComparer());
                    gridFolder.DataSource = allItems;
                    gridFolder.DataBind();
                    lblPath.Text = site.ServerRelativeUrl;
                }
            }
            catch (Exception ex)
            {
                Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId4", "alert('Invalid URL: please enter a valid site URL within the same site collection as the source items.');", true);
            }

        }
        private void OpenFolder(DataGridItem item)
        {
            InitSrcParameters();

            #region Object model
            try
            {

                using (SPSite site = new SPSite(txtUrl.Text.Trim()))
                {

                    using (SPWeb web = site.OpenWeb())
                    {

                        List<DataGridItem> allItems = new List<DataGridItem>();
                        SPFolder folder;
                        if (!String.IsNullOrEmpty(item.ListGuid)) // this is a library item
                        {
                            SPList list = web.Lists[new Guid(item.ListGuid)];
                            folder = list.RootFolder;
                        }
                        else // this is a folder
                        {
                            folder = web.GetFolder(item.Url);
                        }

                        foreach (SPFolder o in folder.SubFolders)
                        {
                            if (!IsInternalLibrary(o.Name))
                            {
                                DataGridItem i = new DataGridItem();
                                i.Url = o.ServerRelativeUrl;
                                i.Title = o.Name;
                                allItems.Add(i);
                            }
                        }
                        m_currentItem = new DataGridItem(folder);
                        allItems.Sort(new DataGridItemComparer());
                        gridFolder.DataSource = allItems;
                        gridFolder.DataBind();
                        lblPath.Text = m_currentItem.Url;
                    }
                }

            }
            catch (Exception ex)
            {
                Alert(ex.Message, false);
            }
            // lblPath.Text = lblPath.Text.Trim().Substring(0, lblPath.Text.Trim().LastIndexOf("/"));
            #endregion
            return;

            #region client model
            //InitSrcParameters();
            //try
            //{
            //    if (m_clientContext == null)
            //        m_clientContext = GetCurrentContext();
            //    FileOperationService m_fileOperationService = new FileOperationService();
            //    List<DataGridItem> allItems = new List<DataGridItem>();
            //    Folder folder;
            //    if (!String.IsNullOrEmpty(item.ListGuid)) // this is a library item
            //    {
            //        List list = m_clientContext.Web.Lists.GetById(new Guid(item.ListGuid));
            //        folder = list.RootFolder;
            //    }
            //    else // this is a folder
            //    {
            //        folder = m_clientContext.Web.GetFolderByServerRelativeUrl(item.Url);
            //    }
            //    m_clientContext.Load(folder.Folders);
            //    m_clientContext.Load(folder);

            //    m_currentFolder = folder;

            //    if (!String.IsNullOrEmpty(item.ListGuid) && new Guid(item.ListGuid).Equals(m_srcListId))
            //    {
            //        //m_needFolderCheck = true;
            //    }


            //    m_clientContext.ExecuteQuery();

            //    //list subfolders
            //    List<SPFolderObject> subFolders = new List<SPFolderObject>();
            //    subFolders = m_fileOperationService.GetSubFolders(folder.ServerRelativeUrl, txtUrl.Text.Trim());

            //    foreach (Folder o in folder.Folders)
            //    {
            //        if (!IsInternalLibrary(o.Name))
            //        {
            //            DataGridItem i = new DataGridItem();
            //            i.Url = o.ServerRelativeUrl;
            //            i.Title = o.Name;
            //            allItems.Add(i);
            //        }
            //    }
            //    m_currentItem = new DataGridItem(folder);
            //    gridFolder.DataSource = allItems;
            //    gridFolder.DataBind();
            //    lblPath.Text = m_currentItem.Url;
            //}
            //catch
            //{
            //    Alert("Copy/Move only supports in the same web application", false);
            //}
            #endregion
        }
        private void OnMoveAction(object state)
        {
            string errorMsg = string.Empty;
            OnActionArg arg = state as OnActionArg;
            try
            {
                string sourceUrl = arg.TargetUrl;
                //if move opertion happens within the same site collection, we keep the document id
                //if (IsSameSiteCollection())
                //{
                //    // in case this is an error "The security validation for this page is invalid."
                //    SPWeb web = SPContext.Current.Web;
                //    //Microsoft.SharePoint.Administration.SPWebApplication webApp = web.Site.WebApplication;
                //    //turn security validation off
                //   // webApp.FormDigestSettings.Enabled = false;
                //    SPSecurity.RunWithElevatedPrivileges(delegate()
                //    {
                //        web.AllowUnsafeUpdates = true;
                //        MoveWithinSiteCollection(state,web);
                //        web.AllowUnsafeUpdates = false;
                //    });
                   
                //    //turn security validation on
                //   // webApp.FormDigestSettings.Enabled = true;
                //}
                //else
                //{
                    OnMoveOperation(state);
                //}
                
            }
            catch (Exception ex)
            {
                isSuccefull = false;
                errorMsg = ex.Message;
            }
            if (isSuccefull)
            {
                Alert("Operation successfully completed", true);
            }
            else
            {
                Alert("Operation Failed with following error message " + errorMsg, false);
            }
        }
        private void OnCopyAction(object state)
        {
            try
            {
                m_srcListId = new Guid(Request.QueryString["ListID"]);
                m_webUrl = txtUrl.Text.Trim();
                string currentPath = string.Empty;
                //AutoResetEvent autoResetEvent = new AutoResetEvent(false);
                OnActionArg arg = (OnActionArg)state;
                // Guid listID=new Guid(HtmlPage.Document.QueryString["ListID"]);
                currentPath = arg.TargetUrl;
                foreach (int ID in arg.IDList)
                {
                    //AutoResetEvent event1 = new AutoResetEvent(false);
                    String result = "";


                    if (m_fileOperationService == null)
                        m_fileOperationService = new FileOperationService();
                    //get file name
                    result = m_fileOperationService.GetName(m_srcListId, ID);

                    if (result.StartsWith("File#;"))
                    {
                        //copy single file
                        WriteLog(ActionType.Start, OPerationType.Copy, FileType.File, result);
                        m_fileOperationService.CopySingleFile(m_srcListId, ID, m_webUrl, arg.TargetUrl, false, false);
                        WriteLog(ActionType.End, OPerationType.Copy, FileType.File, result);
                    }
                    else//this is a folder
                    {
                        String relativeUrl = "";
                        List<int> contentID = null;
                        #region Create folder
                        WriteLog(ActionType.Start, OPerationType.Copy, FileType.Folder, result);
                        relativeUrl = m_fileOperationService.CreateFolder(m_webUrl, arg.TargetUrl, result.Substring(result.IndexOf("#;") + 2));
                        WriteLog(ActionType.End, OPerationType.Copy, FileType.Folder, result);
                        currentPath = relativeUrl;
                        #endregion

                        contentID = m_fileOperationService.GetFolderContents(m_srcListId, ID);

                        //if this folder has subfolders,then  do iterate

                        List<SPFolderObject> subFolders = new List<SPFolderObject>();

                        subFolders = m_fileOperationService.GetSubFoldersByFolderName(m_srcListId, ID);

                        OnActionArg newArg = null;
                        if (subFolders.Count != 0)
                        {

                            for (int i = 0; i < subFolders.Count; i++)
                            {
                                List<int> folderIDs = new List<int>();
                                newArg = new OnActionArg();
                                newArg.TargetUrl = currentPath; ;
                                folderIDs.Add(((SPFolderObject)subFolders[i]).ID);

                                if (contentID != null && contentID.Count != 0)
                                {
                                    foreach (int cID in contentID)
                                    {
                                        folderIDs.Add(cID);
                                    }
                                }
                                newArg.IDList = folderIDs;
                                newArg.Depth = i + 1;
                                OnCopyAction(newArg);
                            }
                        }
                        else
                        {
                            newArg = new OnActionArg();
                            newArg.TargetUrl = relativeUrl;
                            ///TODO
                            newArg.IDList = contentID;
                            newArg.Depth = 1;
                            OnCopyAction(newArg);
                        }
                        //autoResetEvent.Set();
                    }
                }

            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
        private bool IsInternalLibrary(string name)
        {
            if (name.Trim().ToUpper() == "ANALYTICSREPORTS" ||
            name.Trim().ToUpper() == "REPORTING" ||
                name.Trim().ToUpper() == "_VTI_PVT" ||
                name.Trim().ToUpper() == "_CATALOGS" ||
                name.Trim().ToUpper() == "M" ||
                name.Trim().ToUpper() == "_PRIVATE" ||
                name.Trim().ToUpper() == "STYLE LIBRARY" ||
                name.Trim().ToUpper() == "SITEASSETS" ||
                name.Trim().ToUpper() == "FORMSERVERTEMPLATES" ||
                name.Trim().ToUpper() == "_CTS" ||
                name.Trim().ToUpper() == "FORMS" ||
                name.Trim().ToUpper() == "SITE ASSETS" ||
                name.Trim().ToUpper() == "FORM TEMPLATES" ||
                name.Trim().ToUpper() == "CUSTOMIZED REPORTS" ||
                name.Trim().ToUpper() == "SITE PAGES" ||
                name.Trim().ToUpper() == "REPORTING TEMPLATES" ||
                name.Trim().ToUpper() == "SITEPAGES" ||
                name.Trim().ToUpper() == "VARIATION LABELS" ||
                name.Trim().ToUpper() == "RELATIONSHIPS LIST" ||
                name.Trim().ToUpper() == "WORKFLOWTASKS" ||
                name.Trim().ToUpper() == "LONG RUNNING OPERATION STATUS" ||
                name.Trim().ToUpper() == "PUBLISHEDLINKS" ||
                name.Trim().ToUpper() == "SITECOLLECTIONIMAGES" ||
                name.Trim().ToUpper() == "CACHE PROFILES" ||
                name.Trim().ToUpper() == "REPORTS LIST" ||
                name.Trim().ToUpper() == "IMAGES" ||
                name.Trim().ToUpper() == "REUSABLECONTENT" ||
                name.Trim().ToUpper() == "NOTIFICATION PAGES" ||
                name.Trim().ToUpper() == "LISTS" ||
                name.Trim().ToUpper() == "QUICK DEPLOY ITEMS" ||
                name.Trim().ToUpper() == "PAGES" ||
                name.Trim().ToUpper() == "SITE COLLECTION IMAGES" ||
                name.Trim().ToUpper() == "SITE COLLECTION DOCUMENTS" ||
                name.Trim().ToUpper() == "SITECOLLECTIONDOCUMENTS" ||
                name.Trim().ToUpper() == "IWCONVERTEDFORMS" ||
                name.Trim().ToUpper() == "_THEMES" ||
                name.Trim().ToUpper() == "WORKFLOWS" ||
                name.Trim().ToUpper() == "WEBPARTPAGE" ||
                name.Trim().ToUpper() == "WIKIS" ||
                name.Trim().ToUpper() == "PUBLISHINGIMAGES"||
                name.Trim().ToUpper() == "MEETING MINUTES TEMPLATE" ||
                name.Trim().ToUpper() == "MEETING MINUTES REPORT LIBRARY" ||
                name.Trim().ToUpper() == "MEETING MINUTES BASE TEMPLATE"

                )
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        private ClientContext GetCurrentContext()
        {
            ClientContext client = new ClientContext(txtUrl.Text.Trim());
            client.Credentials = new System.Net.NetworkCredential(ConfigurationManager.AppSettings["POWERUSERNAME"],
                ConfigurationManager.AppSettings["POWERUSERPWD"], ConfigurationManager.AppSettings["POWERUSERDOMAIN"]);
            return client;
        }
        private void OnMoveOperation(object state)
        {
            bool keepDocumentID = IsSameSiteCollection();
            m_srcListId = new Guid(Request.QueryString["ListID"]);
            m_webUrl = txtUrl.Text.Trim();
            string currentPath = string.Empty;
            //AutoResetEvent autoResetEvent = new AutoResetEvent(false);
            OnActionArg arg = (OnActionArg)state;
            // Guid listID=new Guid(HtmlPage.Document.QueryString["ListID"]);
            currentPath = arg.TargetUrl;
            foreach (int ID in arg.IDList)
            {
                // AutoResetEvent event1 = new AutoResetEvent(false);
                String result = "";

                #region Get file or folder name
                if (m_fileOperationService == null)
                    m_fileOperationService = new FileOperationService();

                result = m_fileOperationService.GetName(m_srcListId, ID);
                #endregion
                if (result.StartsWith("File#;"))
                {
                    //copy file
                    WriteLog(ActionType.Start, OPerationType.Move, FileType.File, result);
                    m_fileOperationService.CopySingleFile(m_srcListId, ID, m_webUrl, arg.TargetUrl, true,keepDocumentID);
                    WriteLog(ActionType.End, OPerationType.Move, FileType.File, result);
                    //remove the file

                    m_fileOperationService.DeleteSingleItem(m_srcListId, ID);
                }
                else//this is a folder
                {
                    String relativeUrl = "";
                    List<int> contentID = null;

                    //create folder
                    WriteLog(ActionType.Start, OPerationType.Move, FileType.Folder, result);
                    relativeUrl = m_fileOperationService.CreateFolder(m_webUrl, arg.TargetUrl, result.Substring(result.IndexOf("#;") + 2));
                    WriteLog(ActionType.End, OPerationType.Move, FileType.Folder, result);
                    currentPath = relativeUrl;

                    //if this folder has subfolders,then  do iterate
                    List<SPFolderObject> subFolders = new List<SPFolderObject>();

                    subFolders = m_fileOperationService.GetSubFoldersByFolderName(m_srcListId, ID);

                    OnActionArg newArg = null;
                    if (subFolders.Count != 0)
                    {

                        for (int i = 0; i < subFolders.Count; i++)
                        {
                            List<int> folderIDs = new List<int>();
                            newArg = new OnActionArg();
                            newArg.TargetUrl = currentPath; ;
                            folderIDs.Add(((SPFolderObject)subFolders[i]).ID);

                            if (i == subFolders.Count - 1)
                            {
                                //get folde contents
                                contentID = m_fileOperationService.GetFolderContents(m_srcListId, ID);

                                if (contentID != null && contentID.Count != 0)
                                {
                                    foreach (int cID in contentID)
                                    {
                                        folderIDs.Add(cID);
                                    }
                                }
                            }
                            newArg.IDList = folderIDs;
                            newArg.Depth = i + 1;
                            OnMoveOperation(newArg);

                            //remove all content ids,otherwise contents will copy several times.
                            //contentID.Clear();
                        }
                    }
                    else
                    {

                        contentID = m_fileOperationService.GetFolderContents(m_srcListId, ID);

                        newArg = new OnActionArg();
                        newArg.TargetUrl = relativeUrl;
                        ///TODO
                        newArg.IDList = contentID;
                        newArg.Depth = 1;
                        OnMoveOperation(newArg);
                        //if there is no subfolders and no content, then delete the folder.
                        //remove file                    

                    }
                    // event2.Close();
                    //autoResetEvent.Set();
                }
            }

        }
        private void OnMove(object state)
        {
            //m_srcListId = new Guid(Request.QueryString["ListID"]);
            //m_webUrl = txtUrl.Text.Trim();
            //try
            //{
            //    //AutoResetEvent autoResetEvent = new AutoResetEvent(false);
            //    OnActionArg arg = (OnActionArg)state;

            //    foreach (int ID in arg.IDList)
            //    {
            //        #region Copy One single file
            //        //AutoResetEvent event1 = new AutoResetEvent(false);
            //        String result = "";

            //        #region Get file or folder name
            //        FileOperationService m_srv_client = new FileOperationService();


            //        result = m_srv_client.GetName(m_srcListId, ID);

            //        #endregion
            //        //autoResetEvent.Reset();
            //        // AutoResetEvent event2 = new AutoResetEvent(false);
            //        if (result.StartsWith("File#;"))
            //        {
            //            //copy file
            //            m_srv_client.CopySingleFile(m_srcListId, ID, m_webUrl, arg.TargetUrl,true);

            //            //remove file                      
            //            m_srv_client.DeleteSingleItem(m_srcListId, ID);
            //            m_srv_client = new FileOperationService();
            //            // event1 = new AutoResetEvent(false);                      
            //        }
            //        else//this is a folder
            //        {
            //            String relativeUrl = "";
            //            List<int> contentID = null;


            //            relativeUrl = m_srv_client.CreateFolder(m_webUrl, arg.TargetUrl, result.Substring(result.IndexOf("#;") + 2));



            //            contentID = m_srv_client.GetFolderContents(m_srcListId, ID);

            //            OnActionArg newArg = new OnActionArg();
            //            newArg.TargetUrl = relativeUrl;
            //            newArg.IDList = contentID;
            //            newArg.Depth = 1;
            //            OnCopyAction(newArg);
            //            //autoResetEvent.Set();
            //        }
            //    }
            //}
            //catch (Exception ex)
            //{
            //    isSuccefull = false;
            //}
            //        #endregion

            //if (isSuccefull)
            //{
            //    Alert("Operation successfully completed", true);
            //}
            //else
            //{
            //    Alert("Operation Failed", false);
            //}
        }
        void HasCheckOutFiles(List<int> ids, Guid listID)
        {
            //if user does not have delete permission, then disable move button
            SPList currentList = SPContext.Current.Web.Lists[listID];
            if (!currentList.DoesUserHavePermissions(SPBasePermissions.DeleteListItems))
            {
                hasDeletePermission = false;
                return;
            }
            foreach (int i in ids)
            {
                SPListItem item = currentList.GetItemById(i);
                //if item is file
                if (item.FileSystemObjectType == SPFileSystemObjectType.File)
                {
                    if (item.File.CheckOutType != Microsoft.SharePoint.SPFile.SPCheckOutType.None)
                    {
                        hasCheckedOut = true;
                        return;
                    }
                }
                else // if item is folder
                {
                    hasFiles((SPFolder)item.Folder);
                }
            }
        }
        private void hasFiles(SPFolder f)
        {

            if (f.Files.Count > 0)
            {
                foreach (SPFile file in f.Files)
                {
                    if (file.CheckOutType != Microsoft.SharePoint.SPFile.SPCheckOutType.None)
                    {
                        hasCheckedOut = true;
                        return;
                    }
                }
            }

            if (f.SubFolders.Count > 0)
            {
                foreach (SPFolder folder in f.SubFolders)
                {
                    hasFiles(folder);
                }
            }
        }
        void WriteLog(ActionType aType, OPerationType oType, FileType iType, string itemName)
        {

            logs = new StringBuilder();
            logs.Append(divLogs.InnerText + "</br>");
            if (aType == ActionType.Start && iType == FileType.File)
            {


                if (oType == OPerationType.Move)
                {
                    logs.Append(string.Format("<font color='red'>Start to move {0}.......</font></br>", itemName));
                }
                else
                {
                    logs.Append(string.Format("<font color='red'>Start to copy {0}.......</font></br>", itemName));
                }
            }
            if (aType == ActionType.Start && iType == FileType.Folder)
            {


                if (oType == OPerationType.Move)
                {
                    logs.Append(string.Format("<font color='red'>Start to move {0}.......</font></br>", itemName));
                }
                else
                {
                    logs.Append(string.Format("<font color='red'>Start to move {0}.......</font></br>", itemName));
                }
            }

            if (aType == ActionType.End && iType == FileType.File)
            {


                if (oType == OPerationType.Move)
                {
                    logs.Append(string.Format("complete moving {0}.......</br>", itemName));
                }
                else
                {
                    logs.Append(string.Format("complete copying {0}.......</br>", itemName));
                }
            }
            if (aType == ActionType.End && iType == FileType.Folder)
            {


                if (oType == OPerationType.Move)
                {
                    logs.Append(string.Format("complete moving {0}.......</br>", itemName));
                }
                else
                {
                    logs.Append(string.Format("complete moving {0}.......</br>", itemName));
                }
            }
            divLogs.InnerHtml = "";
            divLogs.InnerHtml = logs.ToString();
        }
        private void Alert(string message, bool isSuccessed)
        {
            if (isSuccessed)
            {
                divLogTitle.Visible = false;
                divLogs.Visible = false;
                divLoading.Visible = false;

                Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId1", "jAlert('" + message + "','Alert Dialog',function(){window.frameElement.commitPopup();});", true);

            }
            else
            {
                divLogTitle.Visible = true;
                divLogs.Visible = true;
                divLoading.Visible = false;
                Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId3", "<script language='javascript'>jAlertError('" + message + "');</script>");
            }
        }

        bool IsSameSiteCollection()
        {
            using (SPSite originalSite = SPContext.Current.Web.Site)
            {
                using (SPSite destSite = new SPSite(txtUrl.Text.Trim()))
                {
                    if (originalSite.Url == destSite.Url)
                        return true;
                    else
                        return false;
                }
            }

           
        }
        string GetDestinationURL()
        {
            string targerUrl=string.Empty;
            string url = txtUrl.Text.Trim();

           Regex reg = new Regex(@"(https?://([-\w\.]+)+(:\d+)?(/([\w/_\.]?(\?\S+))?)?)",RegexOptions.IgnoreCase);
           Match mc= reg.Match(url);
           if (mc != null && mc.Groups.Count > 0)
               targerUrl =mc.Groups[0].Value;
         
            if(targerUrl.EndsWith("/"))
            {
                targerUrl=targerUrl.Substring(0, targerUrl.Length - 1);
            }
            return targerUrl;

        }

        public void MoveWithinSiteCollection(object state,SPWeb web)
        {
            string moveURL = GetDestinationURL();
            m_srcListId = new Guid(Request.QueryString["ListID"]);
            m_webUrl = txtUrl.Text.Trim();
            string currentPath = string.Empty;
            SPFile file = null;
           
            SPDocumentLibrary originalDoc = (SPDocumentLibrary)web.Lists[m_srcListId];
            //AutoResetEvent autoResetEvent = new AutoResetEvent(false);
            OnActionArg arg = (OnActionArg)state;
            // Guid listID=new Guid(HtmlPage.Document.QueryString["ListID"]);
            currentPath = arg.TargetUrl;
            foreach (int ID in arg.IDList)
            {
                // AutoResetEvent event1 = new AutoResetEvent(false);
                String result = "";

                #region Get file or folder name
                if (m_fileOperationService == null)
                    m_fileOperationService = new FileOperationService();

                result = m_fileOperationService.GetName(m_srcListId, ID);
                #endregion
                if (result.StartsWith("File#;"))
                {
                    file = originalDoc.GetItemById(ID) != null ? originalDoc.GetItemById(ID).File : null;
                    if (file != null)
                    {
                        WriteLog(ActionType.Start, OPerationType.Move, FileType.File, result);
                        file.MoveTo(moveURL+arg.TargetUrl +"/"+ file.Name);
                        
                        WriteLog(ActionType.End, OPerationType.Move, FileType.File, result);
                    }
                    
                }
                else//this is a folder
                {
                    String relativeUrl = "";
                    List<int> contentID = null;

                    //create folder
                    WriteLog(ActionType.Start, OPerationType.Move, FileType.Folder, result);
                    relativeUrl = m_fileOperationService.CreateFolder(m_webUrl, arg.TargetUrl, result.Substring(result.IndexOf("#;") + 2));
                    WriteLog(ActionType.End, OPerationType.Move, FileType.Folder, result);
                    currentPath = relativeUrl;

                    //if this folder has subfolders,then  do iterate
                    List<SPFolderObject> subFolders = new List<SPFolderObject>();

                    subFolders = m_fileOperationService.GetSubFoldersByFolderName(m_srcListId, ID);

                    OnActionArg newArg = null;
                    if (subFolders.Count != 0)
                    {

                        for (int i = 0; i < subFolders.Count; i++)
                        {
                            List<int> folderIDs = new List<int>();
                            newArg = new OnActionArg();
                            newArg.TargetUrl = currentPath; ;
                            folderIDs.Add(((SPFolderObject)subFolders[i]).ID);

                            if (i == subFolders.Count - 1)
                            {
                                //get folde contents
                                contentID = m_fileOperationService.GetFolderContents(m_srcListId, ID);

                                if (contentID != null && contentID.Count != 0)
                                {
                                    foreach (int cID in contentID)
                                    {
                                        folderIDs.Add(cID);
                                    }
                                }
                            }
                            newArg.IDList = folderIDs;
                            newArg.Depth = i + 1;
                            MoveWithinSiteCollection(newArg,web);

                            //remove all content ids,otherwise contents will copy several times.
                            //contentID.Clear();
                        }
                    }
                    else
                    {

                        contentID = m_fileOperationService.GetFolderContents(m_srcListId, ID);

                        newArg = new OnActionArg();
                        newArg.TargetUrl = relativeUrl;
                        ///TODO
                        newArg.IDList = contentID;
                        newArg.Depth = 1;
                        MoveWithinSiteCollection(newArg,web);
                        //if there is no subfolders and no content, then delete the folder.
                        //remove file                    

                    }
                    // event2.Close();
                    //autoResetEvent.Set();
                }
            }
        }
        #endregion
    }

    internal enum OPerationType { Move, Copy };
    internal enum FileType { File, Folder };
    internal enum ActionType { Start, End };
    public class OnActionArg
    {
        public List<int> IDList { get; set; }
        public String TargetUrl { get; set; }
        public int Depth { get; set; }
    }
}
